Subject: Re: one more... iproute commands lockup whole system

From: Patrick McHardy <[email-masked]>
Date: Wed, 04 Apr 2007 16:07:56 +0200

jamal wrote:
> On Wed, 2007-04-04 at 15:36 +0200, Patrick McHardy wrote:
> 
>>It would be interesting to find out what the problem is exactly.
>>The configuration itself looks harmless, so I'm guessing its
>>rather a deadlock than a loop.
> 
> 
> We know it is a deadlock. 
> If you redirect the first time queue lock for eth0 will be held, before
> it is released if you do another redirect, it will again be heading
> towards eth0 and it will deadlock on grabbing the queue lock.

He only used a single redirect to eth0.5, but its probably due to the
fact that the VLAN hard_start_xmit function transmits on eth0 again.
How about adding something like ifb's ri_tasklet to act_mirred?